/*
 * fre.c - 
 */
static char rcsid[] = "fre.c,v 2.1 1995-04-02 10:18:04+0900 candy Exp";
#define NULL 0
#define FALSE 0
#define TRUE 1
#define SUCCESS 0
#define ERROR (-1)

#define is1kanji(c) ((0x81<=(unsigned char)(c))&&((unsigned char)(c)<=0x9f)||(0xe0<=(unsigned char)(c))&&((unsigned char)(c)<=0xfc))
#define MACRONEXT1(s) ((s)+(is1kanji((s)[0])?(1+((s)[1]!='\0')):((s)[0]!='\0')))
#define isslash(c) ((c)=='/'||(c)=='\\')

#define NEXTWCHAR(wc,s) (((wc)=(unsigned char)*(s)++),(is1kanji(wc)?(*(s)!='\0'?((wc)=(wc)<<8|(unsigned char)*(s)++):((wc)='\0')):(wc)))

#define isalpha(c) (((c)>='A'&&(c)<='Z')||((c)>='a'&&(c)<='z'))
#define toupper(c) (((c)>='a'&&(c)<='z')?(c)-0x20:(c))
#define wtoupper(wc) (((unsigned short)(wc)<0x100)?toupper(wc):(wc))

#define ANYSTRING ((short)0xD62A) /* '*' */
#define ANYCHAR ((short)0xD63F) /* '?' */
#define CHARSET ((short)0xD65B) /* [....] */
#define NOT_CHARSET ((short)0xD65E) /* [^....] */
#define RANGE ((short)0xD62D) /* [ .. `-'..] */

#define isspecial(c) (((c)&0xff00)==0xD600)

/*
 *
 */
int ignore_case = FALSE;

/*
 *
 */
extern int
fre_ignore_case(int new)
{
	int old = ignore_case;
	if (new != -1)
		ignore_case = new;
	return old;
}/* fre_ignore_case */

/*
 * string  short dbuf[dsize] ɃRpCB
 * dbuf ̍Ō '\0' ݒ肷B
 * G[ȂG[bZ[WԂBȂ NULL ԂB
 */
extern char *
fre_compile(short *dbuf, int dsize, const char *string)
{
	short *dst, *limit;
	int ch;

#define SETWCHAR(wc) {if (dst < limit) *dst++ = (wc);}

	limit = dbuf + dsize;
	dst = dbuf;
	NEXTWCHAR(ch, string);
	while (dst < limit && ch != '\0') {
		switch (ch) {
		case '\\':
			NEXTWCHAR(ch, string);
			if (ch == '\0') {
				return "No character after \\";
			}
			SETWCHAR(ch);
			NEXTWCHAR(ch, string);
			break;
		case '?':
			SETWCHAR(ANYCHAR);
			NEXTWCHAR(ch, string);
			break;
		case '*':
			SETWCHAR(ANYSTRING);
			NEXTWCHAR(ch, string);
			break;
		case '[':
			if (*string == '\0') {
				SETWCHAR('[');
				NEXTWCHAR(ch, string);
			}
			else {
				short *lengthp;
				int range_available;
				NEXTWCHAR(ch, string);
				if (ch == '^') {
					SETWCHAR(NOT_CHARSET);
					NEXTWCHAR(ch, string);
				}
				else {
					SETWCHAR(CHARSET)
				}
				lengthp = dst;
				SETWCHAR(0); /* keep space for length */
				if (ch == ']') {
					SETWCHAR('[');
					NEXTWCHAR(ch, string);
				}
				range_available = FALSE;
				while (dst < limit && ch != '\0' && ch != ']') {
					if (ch == '-' && range_available) {
						short lower;
						NEXTWCHAR(ch, string);
						lower = dst[-1];
						dst[-1] = RANGE;
						SETWCHAR(lower);
						SETWCHAR(ch);
						range_available = FALSE;
					}
					else {
						SETWCHAR(ch);
						range_available = TRUE;
					}
					NEXTWCHAR(ch, string);
				}/* while */
				if (ch == '\0') {
					return "Missing ]";
				}
				if (dst < limit) {
					*lengthp = dst - lengthp - 1;
#if 0
	/*
	 * a:/[a-c/]*  fre_list (in frex.c) ŎšƂȂ邪A
	 * dlƂƂɂ悤B
	 */
					while (++lengthp < dst) {
						if (isslash(*lengthp))
							return "/ or \\ in [..]";
					}
#endif
					NEXTWCHAR(ch, string);
				}
			}
			break; /* '[' */
		case '"':
		case '\'':
			{
				int term = ch;
				NEXTWCHAR(ch, string);
				while (ch != '\0' && ch != term) {
					SETWCHAR(ch);
					NEXTWCHAR(ch, string);
				}/* while */
				if (ch == '\0') {
					return term == '"' ? "Missing \"" : "Missing '";
				}
				NEXTWCHAR(ch, string);
			}
			break;
		default:
			do {
				SETWCHAR(ch);
				NEXTWCHAR(ch, string);
			} while (ch < 0x80 && isalpha(ch));
			break;
		}/* switch */
	}/* while */
	if (dst < limit) {
		*dst = '\0';
		return NULL;
	}
	else
		return "Regex buffer overflow";
}/* fre_compile */

/*
 * string  regex ƃ}b`Ȃ non0 ԂB
 */
extern int
fre_match(const short *regex, const char *string)
{
	{
		/* string compare */
		const char *s1 = string;
		const short *s2 = regex;
		int ch;
		NEXTWCHAR(ch, s1);
		while (ch != '\0' && *s2 != '\0' && !isspecial(*s2) && ch == *s2) {
			NEXTWCHAR(ch, s1);
			s2++;
		}/* while */
		if (ch == '\0' && *s2 == '\0')
			return TRUE;
	}
	while (*regex != '\0') {
		if (*string == '\0' && *regex != ANYSTRING) { /* fast test */
			return FALSE;
		}
		switch (*regex) {
		case ANYCHAR:
			regex++;
			string = MACRONEXT1(string);
			break;
		case ANYSTRING:
			{
				int fast_test;
				regex++;
				fast_test = (!isspecial(*regex) && (unsigned short)*regex < 0x100);
				while (*string != '\0') {
					if (fast_test) {
						short wch = wtoupper(*regex);
						if (ignore_case) {
							while (*string != '\0' && wtoupper(*string) != wch) {
								string = MACRONEXT1(string);
							}/* while */
						}
						else {
							while (*string != '\0' && *string != *regex) {
								string = MACRONEXT1(string);
							}/* while */
						}
					}
					if (fre_match(regex, string))
						return TRUE;
					string = MACRONEXT1(string);
				}/* while */
				/* string does not match regex */
				/* or string == "" */
				return fre_match(regex, string);
			}
			break;
		case NOT_CHARSET: /* [^ */
		case CHARSET: /* [ */
			/* [ab-d] -> CHARSET,4,a,RANGE,b,d */
			{
				int not_set, cnt, match;
				short wc;
				const short *next;
				not_set = *regex == NOT_CHARSET;
				regex++;
				cnt = (int)(*regex++);
				next = regex + cnt;
				match = FALSE;
				NEXTWCHAR(wc, string);
				if (ignore_case)
					wc = wtoupper(wc);
				while (cnt > 0 && !match) {
					if (*regex == RANGE) {
						short lower, higher;
						lower = *(regex + 1);
						higher = *(regex + 2);
						if (ignore_case) {
							lower = wtoupper(lower);
							higher = wtoupper(higher);
						}
						match = ((unsigned short)wc >= (unsigned short)lower) && ((unsigned short)wc <= (unsigned short)higher);
						regex += 3;
						cnt -= 3;
					}
					else {
						short wliteral;
						wliteral = *regex;
						if (ignore_case)
							wliteral = wtoupper(wliteral);
						match = wliteral == wc;
						regex += 1;
						cnt -= 1;
					}
				}/* while */
				regex = next;
				if ((!match && !not_set) || (match && not_set))
					return FALSE;
			}
			break; /* CHARSET */
		default:
			{
				short wc, wliteral;
				NEXTWCHAR(wc, string);
				wliteral = *regex++;
				if (ignore_case) {
					wc = wtoupper(wc);
					wliteral = wtoupper(wliteral);
				}
				if (wliteral != wc)
					return FALSE;
			}
			break;
		}/* switch */
	}/* while */
	if (*string != '\0')
		return FALSE;
	return TRUE;
}/* fre_match */
